<?php

/*
 * EverList - A free email listserv written in PHP.
 * Copyright (C) 2008 by Kris Craig.
 * 07.20.2008
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

require( "config.php" );
require( "common.php" );

foreach ( $_GET as $getvar => $getval )
{
	$$getvar = $getval;
}

$userdata = array();
$userdata = AuthenticateUser();
if ( $userdata["authstatus"] != 1 && $fid == NULL )
{
	UserLogin( $userdata["authstatus"] );
	die();
}

$isadmin = CheckUserAdmin();

GenerateHeader( "EverList - View Profile", TRUE );
$topdata = array();
$topdata = GenerateTop( $userdata );

$profiledata = array();
$profiledata = LoadProfile( $userid );

$profileuserdata = array();
$profileuserdata = LoadUser( $userid );

$viewerprofiledata = array();
$viewerprofiledata = LoadProfile( $userdata["userid"] );

if ( $profiledata["success"] == FALSE )
{
	print $profiledata["errmsg"];
	GenerateBottom();
	GenerateFooter();
	die();
}

?>
<b style="color: #005000; font-size: 14pt">User Profile</b>

<br />
<br />

<table border="1" cellspacing="2" cellpadding="2" width="95%">
<tr>
<td valign="center" align="center">
<?php
if ( trim( $profiledata["avatarurl"] ) == NULL )
{
	print "User has no photo or avatar.";
}
else
{
	/* Limit image size to 245x320 and constrain proportions.  --Kris */
	$sizearray = array();
	$sizearray = getimagesize( $profiledata["avatarurl"] );
	
	$widthlimit = 245;
	$heightlimit = 320;
	
	$oldwidth = $sizearray[0];
	$oldheight = $sizearray[1];
	
	if ( $oldwidth > $widthlimit || $oldheight > $heightlimit )
	{
		$wrpercent = $widthlimit / $oldwidth;
		$hrpercent = $heightlimit / $oldheight;
		
		if ( $wrpercent <= $hrpercent )
		{
			$newwidth = intval( $oldwidth * $wrpercent );
			$newheight = intval( $oldheight * $wrpercent );
		}
		else
		{
			$newwidth = intval( $oldwidth * $hrpercent );
			$newheight = intval( $oldheight * $hrpercent );
		}
	}
	else
	{
		$newwidth = $oldwidth;
		$newheight = $oldheight;
	}
	
	print "<img src=\"" . $profiledata["avatarurl"] . "\" border=\"0\" width=\"$newwidth\" height=\"$newheight\" />";
}

?>
</td>
<td valign="top" align="left" width="75%">
<table border="0" cellspacing="2" cellpadding="2" width="100%">
<tr>
<td align="right">
<b>Display Name:</b> &nbsp;
</td>
<td width="70%">
<?php print $profiledata["fullname"]; ?>
</td>
</tr>
<?php

if ( trim( $profiledata["dob"] ) != NULL 
	&& strcmp( $profiledata["dob"], "0000-00-00" ) )
{
	$dobyear = substr( $profiledata["dob"], 0, 4 );
	$dobmonth = substr( $profiledata["dob"], 5, 2 );
	$dobday = substr( $profiledata["dob"], 8, 2 );
	
	print "<tr><td align=\"right\">";
	print "<b>Birthday:</b> &nbsp;</td><td>";
	print "$dobmonth/$dobday/$dobyear";
	print "</td></tr>";
}

if ( trim( $profiledata["title"] ) != NULL )
{
	print "<tr><td align=\"right\">";
	print "<b>Occupation:</b> &nbsp;";
	print "</td><td>";
	print $profiledata["title"];
	print "</td></tr>";
}

if ( trim( $profiledata["website"] ) != NULL )
{
	print "<tr><td align=\"right\">";
	print "<b>Website:</b> &nbsp;";
	print "</td><td>";
	print "<a href=\"" . $profiledata["website"] . "\" target=\"_blank\">";
	print $profiledata["website"];
	print "</a>";
	print "</td></tr>";
}

if ( trim( $userdata["email"] ) != NULL )
{
	print "<tr><td align=\"right\">";
	print "<b>Email:</b> &nbsp;";
	print "</td><td>";
	print "<a href=\"mailto: everlist-user" . $profiledata["userid"] . "@$maildomain\">";
	print "everlist-user" . $profiledata["userid"] . "@$maildomain";
	print "</a>";
	print "</td></tr>";
}

$locationtext = NULL;
if ( trim( $profiledata["city"] ) != NULL )
{
	$locationtext .= $profiledata["city"];
}
if ( trim( $profiledata["state"] ) != NULL )
{
	if ( $locationtext != NULL )
	{
		$locationtext .= ", ";
	}
	$locationtext .= $profiledata["state"];
}
if ( trim( $profiledata["country"] ) != NULL )
{
	if ( $locationtext != NULL )
	{
		$locationtext .= ", ";
	}
	$locationtext .= $profiledata["country"];
}

if ( trim( $locationtext ) != NULL )
{
	print "<tr><td align=\"right\">";
	print "<b>Location:</b> &nbsp;";
	print "</td><td>";
	print $locationtext;
	print "</td></tr>";
}

if ( trim( $profiledata["homephone"] ) != NULL )
{
	print "<tr><td align=\"right\">";
	print "<b>Home Phone:</b> &nbsp;";
	print "</td><td>";
	print $profiledata["homephone"];
	print "</td></tr>";
}

if ( trim( $profiledata["workphone"] ) != NULL )
{
	print "<tr><td align=\"right\">";
	print "<b>Work Phone:</b> &nbsp;";
	print "</td><td>";
	print $profiledata["workphone"];
	if ( trim( $profiledata["workphoneext"] ) != NULL )
	{
		print " &nbsp;Ext. " . $profiledata["workphoneext"];
	}
	print "</td></tr>";
}

if ( trim( $profiledata["cellphone"] ) != NULL )
{
	print "<tr><td align=\"right\">";
	print "<b>Cell:</b> &nbsp;";
	print "</td><td>";
	print $profiledata["cellphone"];
	print "</td></tr>";
}

if ( trim( $profileuserdata["usersincetimestamp"] ) != NULL )
{
	print "<tr><td align=\"right\">";
	print "<b>User Since:</b> &nbsp;";
	print "</td><td>";
	print date( "m/d/Y, h:i:s (T)", $profileuserdata["usersincetimestamp"] );
	print "</td></tr>";
}

if ( trim( $profileuserdata["lastlogontimestamp"] ) != NULL )
{
	print "<tr><td align=\"right\">";
	if ( trim( $profileuserdata["loggedon"] ) == 1 )
	{
		print "<b>Online Since:</b> &nbsp;";
	}
	else
	{
		print "<b>Last Online:</b> &nbsp;";
	}
	print "</td><td>";
	print date( "m/d/Y, h:i:s (T)", $profileuserdata["lastlogontimestamp"] );
	print "</td></tr>";
}

/* So nosey admins can see when a user last did.... well, anything.  --Kris */
if ( trim( $profileuserdata["lastactiontimestamp"] ) != NULL && $isadmin == TRUE )
{
	print "<tr><td align=\"right\">";
	print "<b>Last Action:</b> &nbsp;";
	print "</td><td>";
	print date( "m/d/Y, h:i:s (T)", $profileuserdata["lastactiontimestamp"] );
	print "</td></tr>";
}

if ( trim( $profiledata["bio"] ) != NULL )
{
	print "<tr><td colspan=\"2\"><hr width=\"100%\" /></td></tr>";
	print "<tr><td align=\"right\">";
	print "<b>Bio:</b> &nbsp;";
	print "</td><td>";
	print $profiledata["bio"];
	print "</td></tr>";
	print "<tr><td colspan=\"2\"><hr width=\"100%\" /></td></tr>";
}

?>
</table>
</td>
</tr>
</table>

<span style="font-size: 8pt">
<br />
<br />
</span>

<b>Post History:</b>

<br />

<?php

$query = "select * from posts where createdbyuserid='" . $userid . "' order by ptimestamp DESC LIMIT $historylimit";
$resulttl1 = mysql_query( $query ) or die( "Query '$query' failed for resulttl1 in viewprofile.php : " . mysql_error() );

$postsdata = array();
$postsdata[0] = 0;
while ( $line = mysql_fetch_array( $resulttl1, MYSQL_ASSOC ) )
{
	$postsdata[0]++;
	$postsdata[$postsdata[0]] = array();
	$sqloop = 0;
	foreach ( $line as $col_value )
	{
		$fieldname = mysql_field_name( $resulttl1, $sqloop );
		$postsdata[$postsdata[0]][$fieldname] = $col_value;
		$sqloop++;
	}
}

?>
<table border="0" cellpadding="0" cellspacing="0" bgcolor="#FFFFFF"><tr><td><img src="images/space1px.gif" height=1 width=15 alt="" /></td><td align=right>

<table border=0 width=749 cellpadding=3 cellspacing=1>
<tr>
<td bgcolor="#449944" width="25%"><table width="100%" cellpadding=0 cellspacing=0 border=0><tr><td align=left><font color="#FFFFFF" style="text-decoration:none" face="Verdana, Arial, Helvetica, sans-serif" size="-2"><b><a class="columnheader" href="javascript: HelpWindow( 'mcolumnshelp.php#forum' );">Forum</a></b></font></td><td width="10%" align=right><table width=10 cellpadding=0 cellspacing=0 border=0><tr><td align=right></td></tr><tr><td align=right></td></tr></table></td></tr></table></td>
<td bgcolor="#227722" width="50%"><table width="100%" cellpadding=0 cellspacing=0 border=0><tr><td align=left><font color="#FFFFFF" style="text-decoration:none" face="Verdana, Arial, Helvetica, sans-serif" size="-2"><b><a class="columnheader" href="javascript: HelpWindow( 'mcolumnshelp.php#subject' );">Subject</a></b></font></td><td width="10%" align=right><table width=10 cellpadding=0 cellspacing=0 border=0><tr><td align=right></td></tr><tr><td align=right></td></tr></table></td></tr></table></td>
<td bgcolor="#449944" width="25%"><table width="100%" cellpadding=0 cellspacing=0 border=0><tr><td align=left><font color="#FFFFFF" style="text-decoration:none" face="Verdana, Arial, Helvetica, sans-serif" size="-2"><b><a class="columnheader" href="javascript: HelpWindow( 'mcolumnshelp.php#datetime' );">Post Date</a></b></font></td><td width="10%" align=right><table width=10 cellpadding=0 cellspacing=0 border=0><tr><td align=right></td></tr><tr><td align=right></td></tr></table></td></tr></table></td>
</tr>

<?php
$rowcol[1] = "#C0F3C0";
$rowcol[0] = "#90EE90";

$displaycount = 0;
for ( $ploop = 1; $ploop <= $postsdata[0]; $ploop++ )
{
	$topicdata = array();
	$topicdata = LoadTopic( $postsdata[$ploop]["tid"] );
	
	$forumdata = array();
	$forumdata = LoadForum( $topicdata["fid"] );
	
	$subscribed = IsSubscribed( $viewerprofiledata, $forumdata["fid"] );
	
	if ( $subscribed == FALSE && $forumdata["ispublic"] == 3 )
	{
		continue;
	}
	
	$displaycount++;
	
	?>
	<tr>
	<td bgcolor="<?php print $rowcol[$displaycount % 2]; ?>" valign=top><font face="Verdana, Arial, Helvetica, sans-serif" size=-2><b><a href="viewforum.php?fid=<?php print $forumdata["fid"]; ?>"><?php print $forumdata["fname"]; ?></a></b></font></td>
	<td bgcolor="<?php print $rowcol[$displaycount % 2]; ?>" valign=top><font face="Verdana, Arial, Helvetica, sans-serif" size=-2><b><a href="viewtopic.php?tid=<?php print $topicdata["tid"] . "#" . $postsdata[$ploop]["pid"]; ?>"><?php print $topicdata["tname"]; ?></a></b></font></td>
	<td bgcolor="<?php print $rowcol[$displaycount % 2]; ?>" valign=top><font face="Verdana, Arial, Helvetica, sans-serif" size=-2><?php print date( "M d, Y @ g:i A (T)", $postsdata[$ploop]["ptimestamp"] ); ?></font></td>
	</tr>
	
	<?php
}

print "</table></td></tr></table>";

if ( $displaycount == 0 )
{
	print "<br />This user has no posts in any forums that are visible to you.<br />";
}

print "<br />";
print "<span style=\"font-size: 8pt; color: red\">";
print "Note - Only posts in forums that are publicly viewable or that you're subscribed to are displayed.<br />Limited to $historylimit most-recent posts.";
print "</span>";

GenerateBottom();
GenerateFooter();
